; DefaultBrowserInRegistry.ahk
; http://www.autohotkey.com/board/topic/89803-set-default-browser-in-registry-correctly-handles-url-files/
;
; If no command line arguments will show GUI. Will run in silent mode if argument passed to it on command line. 
; Silent mode example: DefaultBrowserInRegistry.exe "D:\PortableApps\GoogleChromePortable\GoogleChromePortable.exe"

#SingleInstance, Force
#NoTrayIcon

; Check for Command line Parameters
If(%0%) { ;If command line parameter
	BrowserEXEPath = %1%  ; Get the first parameter
	Goto, LabelCheckPath
}

InputBox, BrowserEXEPath, Set Default Browser In Registry, Type the full path to the location of your Portable Browser EXE (without quotes)`, example: D:\PortableApps\GoogleChromePortable\GoogleChromePortable.exe, , 600

if (ErrorLevel) {
	;MsgBox Cancelled, Nothing written to registry.
	ExitApp
} else {
	Goto, LabelCheckPath
}

;---------------------------------------------------------------
LabelCheckPath:
SplitPath, BrowserEXEPath, , , ExtensionCheck, BrowserEXEName
If (ExtensionCheck <> "exe") {
	MsgBox, ,DefaultBrowserInRegistry ERROR, Does not seem like correct path, could not correctly find EXE extension.`n`nDEBUG REPORT`nBrowserEXEPath is %BrowserEXEPath%`nBrowserEXEName is %BrowserEXEName%`nExtensionCheck is %ExtensionCheck%
	ExitApp
}

;---------------------------------------------------------------
RegDelete, HKEY_CLASSES_ROOT, .htm
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, .htm,,MyHTMLFile
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, .htm,Content Type,text/html

RegDelete, HKEY_CLASSES_ROOT, .html
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, .html,,MyHTMLFile
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, .html,Content Type,text/html

RegDelete, HKEY_CLASSES_ROOT, .mht
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, .mht,,MyHTMLFile
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, .html,Content Type,text/mhtml

RegDelete, HKEY_CLASSES_ROOT, .url
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, .url,,InternetShortcut

;---------------------------------------------------------------
RegDelete, HKEY_CLASSES_ROOT, MyHTMLFile
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, MyHTMLFile,URL Protocol,
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, MyHTMLFile,,%BrowserEXEName%
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, MyHTMLFile\shell\open\command,,"%BrowserEXEPath%" -url "`%1"
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, MyHTMLFile\DefaultIcon,,"%BrowserEXEPath%"`,0

;---------------------------------------------------------------
RegDelete, HKEY_CLASSES_ROOT, InternetShortcut
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut,NeverShowExt,
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut,,Internet Shortcut
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut\shellex\ContextMenuHandlers\{FBF23B40-E3F0-101B-8488-00AA003E56F8},,
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut\shell\open,LegacyDisable,
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut\shell\open,CLSID,{FBF23B40-E3F0-101B-8488-00AA003E56F8}
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut\shell\open\command,,rundll32.exe shdocvw.dll`,OpenURL `%l
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut\DefaultIcon,,"%BrowserEXEPath%"`,0
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, InternetShortcut\CLSID,,{FBF23B40-E3F0-101B-8488-00AA003E56F8}
Regwrite, REG_DWORD, HKEY_CLASSES_ROOT, InternetShortcut,EditFlags,2

RegDelete, HKEY_CLASSES_ROOT, http
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, http,URL Protocol,
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, http,Source Filter,{E436EBB6-524F-11CE-9F53-0020AF0BA770}
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, http,,URL:HyperText Transfer Protocol
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, http\shell\open\command,,"%BrowserEXEPath%" -url "`%1"
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, http\DefaultIcon,,"%BrowserEXEPath%"`,0
Regwrite, REG_DWORD, HKEY_CLASSES_ROOT, http,EditFlags,2

RegDelete, HKEY_CLASSES_ROOT, https
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, https,URL Protocol,
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, https,Source Filter,{E436EBB6-524F-11CE-9F53-0020AF0BA770}
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, https,,URL:HyperText Transfer Protocol with Privacy
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, https\shell\open\command,,"%BrowserEXEPath%" -url "`%1"
Regwrite, REG_SZ, HKEY_CLASSES_ROOT, https\DefaultIcon,,"%BrowserEXEPath%"`,0
Regwrite, REG_DWORD, HKEY_CLASSES_ROOT, https,EditFlags,2

;---------------------------------------------------------------
; StartMenuInternet and Capabilities

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet,,%BrowserEXEName%
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\DefaultIcon,,"%BrowserEXEPath%"`,0

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%,,%BrowserEXEName%
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%,LocalizedString,%BrowserEXEName%

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\shell\open\command,,"%BrowserEXEPath%"

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\DefaultIcon,,"%BrowserEXEPath%"`,0

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities\StartMenu,StartMenuInternet,%BrowserEXEName%

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities,ApplicationName,%BrowserEXEName%
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities,ApplicationDescription,%BrowserEXEName%
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities,ApplicationIcon,"%BrowserEXEPath%"`,0
Regwrite, REG_DWORD, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities,Hidden,0

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities\FileAssociations,.url,InternetShortcut
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities\FileAssociations,.html,MyHTMLFile
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities\FileAssociations,.htm,MyHTMLFile
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities\FileAssociations,.mht,MyHTMLFile
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities\URLAssociations,https,MyHTMLFile
Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities\URLAssociations,http,MyHTMLFile

;---------------------------------------------------------------
; RegisteredApplications

Regwrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\RegisteredApplications,%BrowserEXEName%,Software\Clients\StartMenuInternet\%BrowserEXEName%\Capabilities

;---------------------------------------------------------------
; UserChoice

Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\Shell\Associations\UrlAssociations\http\UserChoice,ProgId,MyHTMLFile
Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\Shell\Associations\UrlAssociations\https\UserChoice,ProgId,MyHTMLFile

Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.htm\UserChoice,ProgId,MyHTMLFile
Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.html\UserChoice,ProgId,MyHTMLFile
Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.mht\UserChoice,ProgId,MyHTMLFile
Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.url\UserChoice,ProgId,MyHTMLFile

Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\Shell\Associations\MIMEAssociations\text/html\UserChoice,ProgId,MyHTMLFile
Regwrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\Shell\Associations\MIMEAssociations\text/mhtml\UserChoice,ProgId,MyHTMLFile

;---------------------------------------------------------------

If(%0% = 0) { ;If not silent mode
	MsgBox, ,Done, Done`, Exiting.
}
ExitApp
